<!doctype html>
<html lang="en">
<head>
<title>Contact Form 05</title>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<link href='https://fonts.googleapis.com/css?family=Roboto:400,100,300,700' rel='stylesheet' type='text/css'>
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">
<link rel="stylesheet" href="css/style.css">
</head>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    function onBtnContactClick(){
        console.log("nut duoc nhan");
        // Bước 0: Khởi tạo đối tượng thu thập
        var vObject = {
            name:"",
            email: "",
            contact: "",
        }
        // Bước 1: thu thập dữ liệu
        getDataFromInput(vObject);
        console.log(vObject);
        // Bước 2: Kiểm tra dữ liệu thu thập
        var vCheck = validateData(vObject);
        console.log(vCheck);
        // Bước 3: gọi API xử lý
        if(vCheck == true){
            // create a request
            var vXmlHttpContact = new XMLHttpRequest();
            processAPI(vXmlHttpContact, vObject);
            vXmlHttpContact.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATED) {
                    var vContactInfo = vXmlHttpContact.responseText;                   
                    // Bước 4: hiển thị thông tin
                    displayData(vContactInfo);
                }
            }
        }
    }
        
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm hiển thị thông tin sau khi đăng nhập
    function displayData(paramInfor){
        "use strict";
        console.log(paramInfor);
        alert("Tạo Contact user mới thành công");
    }
    // Hàm xử lý ajax API login
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject){
        "use strict";
        paramRequest.open("POST",gBASE_URL_CONTACTS,true);
        paramRequest.setRequestHeader("Content-Type","application/json;charset=UTF-8");
        paramRequest.send(JSON.stringify(paramObject));
        console.log(paramObject);
    }
    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(email) {
        var re = /\S+@\S+\.\S+/;
        return re.test(email);
    }
    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateData(paramObject) {
        "use strict";
        var vResult = true; // Khởi tạo kết quả kiểm tra là đúng
        
        var vName = paramObject.name.trim();
        var vEmail = paramObject.email.trim(); // Chuẩn hóa dữ liệu
        var vContact = paramObject.contact.trim();

        if ( vName == ""){
            alert("Name is empty");
            vResult = false;
        }
        if (vEmail == "") {
            alert("Email is empty!");
            vResult = false;
        } else {
            if (validateEmail(vEmail) == false) {
                alert("Email is invalid!");
                vResult = false;
            }
        }
        if (vContact == "") {
            alert("Contact is empty!");
            vResult = false;
        }
        return vResult;
    }
    // Hàm thu thập dữ liệu
    // Input là đối tượng chứa dữ liệu thu thập
    function getDataFromInput(paramObject) {
        "use strict";

        var vName = document.getElementById("inp-name");
        var vEmail = document.getElementById("inp-email");
        var vContact = document.getElementById("inp-message");
        
        paramObject.name = vName.value;
        paramObject.email = vEmail.value;
        paramObject.contact = vContact.value;
    }
</script>
<body>
    <section class="ftco-section">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-md-12">
                    <div class="wrapper">
                        <div class="row no-gutters">
                            <div class="col-lg-6">
                                <div class="contact-wrap w-100 p-md-5 p-4">
                                    <h3>Contact us</h3>
                                    <p class="mb-4">
                                        We’re here to help! Send us your query via the form below or send us an<br> 
                                        email at <a href="" class="text-info">helpdesk@gstudio.com</a> for any issue you’re facing
                                    </p>
                                    
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <input type="text" class="form-control" name="name" id="inp-name" placeholder="Name">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <input type="email" class="form-control" name="email" id="inp-email" placeholder="Email">
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <textarea name="message" class="form-control" id="inp-message" cols="30" rows="4" placeholder="Create a message here"></textarea>
                                                </div>
                                            </div>
                                            <div class="col-md-12">
                                                <div class="form-group text-center">
                                                    <button class="btn btn-info" onclick="onBtnContactClick()">Submit</button>
                                                <div class="submitting"></div>
                                                </div>
                                            </div>
                                        </div>
                                    
                                </div>
                            </div>
                            <div class="col-lg-6 d-flex align-items-stretch">
                                <div class="info-wrap w-100 p-5 img" style="background-image: url(1.png); background-color: aqua;">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</body>

</html>
